#include <glib.h>

#include "vwmterm.h"
#include "render.h"

void  ptyterm_render_addch(PTY_TERM *pty_term,chtype ch)
{
   gint  max_x,max_y;
   gint  new_x,new_y;
   gint  x,y;

   getmaxyx(pty_term->active_wnd,max_y,max_x);

   if((ch=='\r') && (pty_term->new_state & PTY_STATE_CPARKED))
      pty_term->new_state &= ~(PTY_STATE_CPARKED);
   if((ch=='\n') && (pty_term->new_state & PTY_STATE_CWRAPPED))
   {
      pty_term->new_state &= ~(PTY_STATE_CWRAPPED); 
      return;      
   }
   
   /*
      if the cursor was parked before the character write we need to
      do several things for an unpark.  1) enable scrolling
      2) advance one line 3) wrap the cursor 4) set the cursor just
      wrapped flag 5) turn of the cursor-is-parked flag.
   */
   if(pty_term->new_state & PTY_STATE_CPARKED)
   {
      if(VWMTERM_IS_SCROLLOK(pty_term))
      {
         scrollok(pty_term->active_wnd,TRUE);
         scroll(pty_term->active_wnd);
         wmove(pty_term->active_wnd,max_y-1,0);
         waddch(pty_term->active_wnd,ch);
         pty_term->new_state &= ~(PTY_STATE_CWRAPPED);
         pty_term->new_state &= ~(PTY_STATE_CPARKED);
      }
      return;
   }
   else
   {
      getyx(pty_term->active_wnd,y,x);
      if(y==max_y-1 && x==max_x-1 && ch!='\r' && ch!='\n')
      {
         scrollok(pty_term->active_wnd,FALSE);
         pty_term->new_state |= PTY_STATE_CPARKED;
         pty_term->new_state |= PTY_STATE_CWRAPPED;
      }
      else scrollok(pty_term->active_wnd,TRUE);
         
      waddch(pty_term->active_wnd,ch);
      getyx(pty_term->active_wnd,new_y,new_x);
      if(x==max_x-1 && new_x==0 && ch!='\r' && ch!='\n')
      pty_term->new_state |= PTY_STATE_CWRAPPED;
      return;
   }

   return;
}

void  ptyterm_render_move(PTY_TERM *pty_term,int y,int x)
{
   gint  max_x,max_y;

   /* always clear CWRAPPED flag.   */
   pty_term->new_state &= ~(PTY_STATE_CWRAPPED);
   
   getmaxyx(pty_term->active_wnd,max_y,max_x);
   if(!(x==max_x-1 && y==max_y-1))
   {
      pty_term->new_state &= ~(PTY_STATE_CPARKED);
      if(VWMTERM_IS_SCROLLOK(pty_term)) scrollok(pty_term->active_wnd,TRUE);
   }

   wmove(pty_term->active_wnd,y,x);

   return;
}


