#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <execinfo.h>
#include <fcntl.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>

#ifdef _VIPER_WIDE
#include <ncursesw/curses.h>
#else
#include <curses.h>
#endif

#include "vwm_signals.h"

#ifdef _DEBUG
void vwm_backtrace(int signum)
{
   char     *term_name=NULL;
   void     *array[10];
   size_t   count;
   char     **strings;
   int      fd=-1;
   size_t   i;

   endwin();

   term_name=ctermid(NULL);
   if(term_name!=NULL)
   {
      fd=open(term_name,O_RDWR);
      if(fd!=-1);
      dup2(fd,STDIN_FILENO);
   }

   count=backtrace(array,10);
   strings=backtrace_symbols(array,count);

   printf("caught signal %d\n\r",signum);
   printf("obtained %zd stack frames.\n",count);
     
   for(i=0;i<count;i++)
   {
      printf("%s\n\r",strings[i]);
   }
     
   free(strings);
   if(fd!=-1) close(fd);
   exit(EXIT_FAILURE);

   return;
}
#endif
